OGRE: Ogre::VertexElement Class Reference - OGRE Documentation

Public Member Functions | Static Public Member Functions | Protected Attributes

# Ogre::VertexElement Class Reference
[RenderSystem]

This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaration. More...

`#include <OgreHardwareVertexBuffer.h>`

Inheritance diagram for Ogre::VertexElement:
[legend]

List of all members.

## Public Member Functions
| VertexElement ()
| Constructor, should not be called directly, only needed because of list.
| VertexElement (unsigned short source, size_t offset, VertexElementType theType, VertexElementSemantic semantic, unsigned short index=0)
| Constructor, should not be called directly, call VertexDeclaration::addElement.
unsigned short | getSource (void) const
| Gets the vertex buffer index from where this element draws it's values.
size_t | getOffset (void) const
| Gets the offset into the buffer where this element starts.
VertexElementType | getType (void) const
| Gets the data format of this element.
VertexElementSemantic | getSemantic (void) const
| Gets the meaning of this element.
unsigned short | getIndex (void) const
| Gets the index of this element, only applicable for repeating elements.
size_t | getSize (void) const
| Gets the size of this element in bytes.
bool | operator== (const VertexElement &rhs) const
void | baseVertexPointerToElement (void *pBase, void **pElem) const
| Adjusts a pointer to the base of a vertex to point at this element.
void | baseVertexPointerToElement (void *pBase, float **pElem) const
| Adjusts a pointer to the base of a vertex to point at this element.
void | baseVertexPointerToElement (void *pBase, RGBA **pElem) const
| Adjusts a pointer to the base of a vertex to point at this element.
void | baseVertexPointerToElement (void *pBase, unsigned char **pElem) const
| Adjusts a pointer to the base of a vertex to point at this element.
void | baseVertexPointerToElement (void *pBase, unsigned short **pElem) const
| Adjusts a pointer to the base of a vertex to point at this element.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static size_t | getTypeSize (VertexElementType etype)
| Utility method for helping to calculate offsets.
static unsigned short | getTypeCount (VertexElementType etype)
| Utility method which returns the count of values in a given type.
static VertexElementType | multiplyTypeCount (VertexElementType baseType, unsigned short count)
| Simple converter function which will turn a single-value type into a multi-value type based on a parameter.
static VertexElementType | getBaseType (VertexElementType multiType)
| Simple converter function which will a type into it's single-value equivalent - makes switches on type easier.
static void | convertColourValue (VertexElementType srcType, VertexElementType dstType, uint32 *ptr)
| Utility method for converting colour from one packed 32-bit colour type to another.
static uint32 | convertColourValue (const ColourValue &src, VertexElementType dst)
| Utility method for converting colour to a packed 32-bit colour type.
static VertexElementType | getBestColourVertexElementType (void)
| Utility method to get the most appropriate packed colour vertex element format.
## Protected Attributes
unsigned short | mSource
| The source vertex buffer, as bound to an index using VertexBufferBinding.
size_t | mOffset
| The offset in the buffer that this element starts at.
VertexElementType | mType
| The type of element.
VertexElementSemantic | mSemantic
| The meaning of the element.
unsigned short | mIndex
| Index of the item, only applicable for some elements like texture coords.

## Detailed Description

This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaration.

Remarks:
  Several vertex buffers can be used to supply the input geometry for a rendering operation, and in each case a vertex buffer can be used in different ways for different operations; the buffer itself does not define the semantics (position, normal etc), the VertexElement class does.

Definition at line 135 of file OgreHardwareVertexBuffer.h.

## Constructor & Destructor Documentation

Ogre::VertexElement::VertexElement | ( |  | ) |

Constructor, should not be called directly, only needed because of list.

Definition at line 150 of file OgreHardwareVertexBuffer.h.

Ogre::VertexElement::VertexElement | ( | unsigned short | source,
|  | size_t | offset,
|  | VertexElementType | theType,
|  | VertexElementSemantic | semantic,
|  | unsigned short | index = `0` |
| ) |  |  |

Constructor, should not be called directly, call VertexDeclaration::addElement.

## Member Function Documentation

void Ogre::VertexElement::baseVertexPointerToElement | ( | void * | pBase,
|  | void ** | pElem |
| ) |  |  | const

Adjusts a pointer to the base of a vertex to point at this element.

Remarks:
  This variant is for void pointers, passed as a parameter because we can't rely on covariant return types.

Parameters:

  | pBase | Pointer to the start of a vertex in this buffer.
  | pElem | Pointer to a pointer which will be set to the start of this element.

Definition at line 218 of file OgreHardwareVertexBuffer.h.

void Ogre::VertexElement::baseVertexPointerToElement | ( | void * | pBase,
|  | float ** | pElem |
| ) |  |  | const

Adjusts a pointer to the base of a vertex to point at this element.

Remarks:
  This variant is for float pointers, passed as a parameter because we can't rely on covariant return types.

Parameters:

  | pBase | Pointer to the start of a vertex in this buffer.
  | pElem | Pointer to a pointer which will be set to the start of this element.

Definition at line 232 of file OgreHardwareVertexBuffer.h.

void Ogre::VertexElement::baseVertexPointerToElement | ( | void * | pBase,
|  | RGBA ** | pElem |
| ) |  |  | const

Adjusts a pointer to the base of a vertex to point at this element.

Remarks:
  This variant is for RGBA pointers, passed as a parameter because we can't rely on covariant return types.

Parameters:

  | pBase | Pointer to the start of a vertex in this buffer.
  | pElem | Pointer to a pointer which will be set to the start of this element.

Definition at line 249 of file OgreHardwareVertexBuffer.h.

void Ogre::VertexElement::baseVertexPointerToElement | ( | void * | pBase,
|  | unsigned char ** | pElem |
| ) |  |  | const

Adjusts a pointer to the base of a vertex to point at this element.

Remarks:
  This variant is for char pointers, passed as a parameter because we can't rely on covariant return types.

Parameters:

  | pBase | Pointer to the start of a vertex in this buffer.
  | pElem | Pointer to a pointer which will be set to the start of this element.

Definition at line 262 of file OgreHardwareVertexBuffer.h.

void Ogre::VertexElement::baseVertexPointerToElement | ( | void * | pBase,
|  | unsigned short ** | pElem |
| ) |  |  | const

Adjusts a pointer to the base of a vertex to point at this element.

Remarks:
  This variant is for ushort pointers, passed as a parameter because we can't rely on covariant return types.

Parameters:

  | pBase | Pointer to the start of a vertex in this buffer.
  | pElem | Pointer to a pointer which will be set to the start of this element.

Definition at line 274 of file OgreHardwareVertexBuffer.h.

static void Ogre::VertexElement::convertColourValue | ( | VertexElementType | srcType,
|  | VertexElementType | dstType,
|  | uint32 * | ptr |
| ) |  |  | `[static]`

Utility method for converting colour from one packed 32-bit colour type to another.

Parameters:

  | srcType | The source type
  | dstType | The destination type
  | ptr | Read / write value to change

static uint32 Ogre::VertexElement::convertColourValue | ( | const ColourValue & | src,
|  | VertexElementType | dst |
| ) |  |  | `[static]`

Utility method for converting colour to a packed 32-bit colour type.

Parameters:

  | src | source colour
  | dst | The destination type

static VertexElementType Ogre::VertexElement::getBaseType | ( | VertexElementType | multiType | ) | `[static]`

Simple converter function which will a type into it's single-value equivalent - makes switches on type easier.

static VertexElementType Ogre::VertexElement::getBestColourVertexElementType | ( | void |  | ) | `[static]`

Utility method to get the most appropriate packed colour vertex element format.

unsigned short Ogre::VertexElement::getIndex | ( | void |  | ) | const

Gets the index of this element, only applicable for repeating elements.

Definition at line 163 of file OgreHardwareVertexBuffer.h.

size_t Ogre::VertexElement::getOffset | ( | void |  | ) | const

Gets the offset into the buffer where this element starts.

Definition at line 157 of file OgreHardwareVertexBuffer.h.

VertexElementSemantic Ogre::VertexElement::getSemantic | ( | void |  | ) | const

Gets the meaning of this element.

Definition at line 161 of file OgreHardwareVertexBuffer.h.

size_t Ogre::VertexElement::getSize | ( | void |  | ) | const

Gets the size of this element in bytes.

unsigned short Ogre::VertexElement::getSource | ( | void |  | ) | const

Gets the vertex buffer index from where this element draws it's values.

Definition at line 155 of file OgreHardwareVertexBuffer.h.

VertexElementType Ogre::VertexElement::getType | ( | void |  | ) | const

Gets the data format of this element.

Definition at line 159 of file OgreHardwareVertexBuffer.h.

static unsigned short Ogre::VertexElement::getTypeCount | ( | VertexElementType | etype | ) | `[static]`

Utility method which returns the count of values in a given type.

static size_t Ogre::VertexElement::getTypeSize | ( | VertexElementType | etype | ) | `[static]`

Utility method for helping to calculate offsets.

static VertexElementType Ogre::VertexElement::multiplyTypeCount | ( | VertexElementType | baseType,
|  | unsigned short | count |
| ) |  |  | `[static]`

Simple converter function which will turn a single-value type into a multi-value type based on a parameter.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

bool Ogre::VertexElement::operator== | ( | const VertexElement & | rhs | ) | const

Definition at line 199 of file OgreHardwareVertexBuffer.h.

References mIndex, mOffset, mSemantic, mSource, and mType.

## Member Data Documentation

unsigned short Ogre::VertexElement::mIndex`[protected]`

Index of the item, only applicable for some elements like texture coords.

Definition at line 147 of file OgreHardwareVertexBuffer.h.

Referenced by operator==().

size_t Ogre::VertexElement::mOffset`[protected]`

The offset in the buffer that this element starts at.

Definition at line 141 of file OgreHardwareVertexBuffer.h.

Referenced by operator==().

VertexElementSemantic Ogre::VertexElement::mSemantic`[protected]`

The meaning of the element.

Definition at line 145 of file OgreHardwareVertexBuffer.h.

Referenced by operator==().

unsigned short Ogre::VertexElement::mSource`[protected]`

The source vertex buffer, as bound to an index using VertexBufferBinding.

Definition at line 139 of file OgreHardwareVertexBuffer.h.

Referenced by operator==().

VertexElementType Ogre::VertexElement::mType`[protected]`

The type of element.

Definition at line 143 of file OgreHardwareVertexBuffer.h.

Referenced by operator==().

The documentation for this class was generated from the following file:

- OgreHardwareVertexBuffer.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:55